# Normalise the SARS forex data into something usable
#
# This is horrible, inefficient string hackery. Deal with it.

import sys
import datetime as D

# Reinventing the wheel yet again. Wee.
try:
    filename = sys.argv[1]
    output = sys.argv[2]
except:
    print 'Usage: %s <input> <output>' % sys.argv[0]
    print 'Highly data format specific. Expect problems'
    sys.exit(1)

f = open(filename, 'rU')
data = f.readlines()
f.close()

for line in data:
   # All the interesting data is bunged together in a single line.
   # This sucks
   if 'tbody' not in line:
      continue
   forex = line.split('</tr>')

values = []

for line in forex:
    if 'id="X"' not in line:
        continue
    data = line.split('</td>')
    res = [data[0]]
    for val in data:
        if 'id="X"' in val:
            res.append(val)
    values.append(res)

# Cleanup values
out = open(output, 'w')
for date, rate in values:
    date = date.replace('<tr><td>', '')
    # The data is already padded to fill in missing dates
    # We `unpad` by dropping Sat, Sun, Christmas and new year
    true_date = D.datetime.strptime(date, '%m/%d/%Y')
    if true_date.weekday() in [5, 6]:
        # Weekend
        continue
    if true_date.month == 12 and true_date.day == 25:
        continue
    if true_date.month == 1 and true_date.day == 1:
        continue
    # Use a sane date format
    date = true_date.strftime('%Y/%m/%d')
    rate = float(rate.replace('<td id="X">', ''))
    out.write('%s,%7.5f\n' % (date, rate))
out.close()
