# DataFrames

x = pandas.Series({'a' : 10, 'b' : 15, 'c' : 16.0, 'd' : 17.5})

y = pandas.Series(np.random.randn(6), index=['a', 'b', 'd', 'e', 'g', 'h'])

x
y

x.name = 'X'
y.name = 'Y'

df = pandas.DataFrame([x, y])

df
df.T

df = pandas.DataFrame({'X' : x, 'Y' : y})

df

df['X']
type(df['X'])

df['X']['a']

df.ix['a']

df.xs('a')

df.ix['a':'c']
df['a':'c']

df['Z'] = 3*df['X']

Z = df.pop('Z')

df

df['L'] = 1

df

df.insert(1, 'Q', [1,2,3,4,5,6,7])

df


df.insert(1, 'M', [1,2,3,4,5,6])

z = pandas.series([1,2,3,4,5,6], index=['a', 'b', 'c', 'd', 'e', 'f'])

df.insert(1, 'M', z)

df.ix['a'].dtype

# Note f is lost

x = pandas.Series(np.random.randn(5), index=['a', 'b', 'c', 'd', 'e'])
y = pandas.Series(np.random.randn(5), index=['a', 'b', 'c', 'd', 'e'])

df = pandas.DataFrame({'X' : x, 'Y' : y})

df

df + df
3 * df

df - df.ix['a']

df - df['X']

(df.T - df['X']).T

np.exp(df)

base = pandas.read_csv('../Examples/baseball.csv')

base

base.ix[20:500, :12].to_string()

base.get_dtype_counts()

